import static java.lang.System.*;
import java.util.HashMap;

public class Test_ED_Table_Entry_
{
   public Test_ED_Table_Entry_(String name, int[] _MD_args_order_)
   {
      this.name = name;
      this._MD_args_order_ = _MD_args_order_;
   }
   public final String name;
   public final int[] _MD_args_order_;

   static HashMap<String, Test_ED_Table_Entry_> dynamicCreate_table = null; // thread-safe problems!
   @SuppressWarnings(value = "unchecked")
   static Object dynamicCreate(Object a1, Object a2)
   {
      if (dynamicCreate_table == null)
      {
         // Just to ensure the compilation of all classes:
         A_A a_a;
         A_B a_b;
         A_C a_c;
         B_B b_B;
         B_C b_c;
         C_C c_c;

         // Base classes:
         //    A B C
         // MD classes:
         //    A_A(A,A) A_B(A,B) A_C(A,C) B_B(B,B) B_C(B,C) C_C(C,C)
         dynamicCreate_table = new HashMap();
         int[] AA = {0, 1}; dynamicCreate_table.put("A"+"+"+"A", new Test_ED_Table_Entry_("A_A", AA));
         int[] AB = {0, 1}; dynamicCreate_table.put("A"+"+"+"B", new Test_ED_Table_Entry_("A_B", AB));
         int[] BA = {1, 0}; dynamicCreate_table.put("B"+"+"+"A", new Test_ED_Table_Entry_("A_B", BA));
         int[] AC = {0, 1}; dynamicCreate_table.put("A"+"+"+"C", new Test_ED_Table_Entry_("A_C", AC));
         int[] CA = {1, 0}; dynamicCreate_table.put("C"+"+"+"A", new Test_ED_Table_Entry_("A_C", CA));
         int[] BB = {0, 1}; dynamicCreate_table.put("B"+"+"+"B", new Test_ED_Table_Entry_("B_B", BB));
         int[] BC = {0, 1}; dynamicCreate_table.put("B"+"+"+"C", new Test_ED_Table_Entry_("B_C", BC));
         int[] CB = {1, 0}; dynamicCreate_table.put("C"+"+"+"B", new Test_ED_Table_Entry_("B_C", CB));
         int[] CC = {0, 1}; dynamicCreate_table.put("C"+"+"+"C", new Test_ED_Table_Entry_("C_C", CC));
      }

      Object result = null;
      try {
         final Class class_a1 = a1.getClass();
         final Class class_a2 = a2.getClass();
         final String searchName = class_a1.getSimpleName()+"+"+class_a2.getSimpleName();
         Test_ED_Table_Entry_ entry = dynamicCreate_table.get(searchName);
         out.println("From "+searchName+" gets "+entry.name);
         Class theClass  = Class.forName(entry.name);
         if (entry._MD_args_order_[0] == 0)
            result = (Object)theClass.getConstructor(class_a1, class_a2, entry._MD_args_order_.getClass()).newInstance(a1, a2, entry._MD_args_order_);
         else
            result = (Object)theClass.getConstructor(class_a2, class_a1, entry._MD_args_order_.getClass()).newInstance(a2, a1, entry._MD_args_order_);
      }
      catch ( Throwable e ){
         err.println( e + " Internal fatal ERROR.");
         exit(-1);
      }

      assert result != null;

      return result;
   }
}

